/* 
 * File:   Sockets.cpp
 * Author: Dimopoulos Elias
 * e-mail: dimopoulos.elias@gmail.com
 * twitter: DimopoulosElias
 * Created on September 15, 2013, 11:31 AM
 */

#include <iostream>
#include "Sockets.h"
#include <curl/curl.h>


string useragent = "Facebook Scanner by E.D";

size_t Sockets::data_write(void* buf, size_t size, size_t nmemb, void* userp)
{
	if(userp)
	{
		std::ostream& os = *static_cast<std::ostream*>(userp);
		std::streamsize len = size * nmemb;
		if(os.write(static_cast<char*>(buf), len))
			return len;
	}

	return 0;
}

CURLcode Sockets::curl_read(const std::string& url, std::ostream& os, long timeout)
{
    CURLcode code(CURLE_FAILED_INIT);
	CURL* curl = curl_easy_init();
        timeout=30;

	if(curl)
	{
		if(CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, &data_write))
		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_NOPROGRESS, 1L))
		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1L))
		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_FILE, &os))
		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_TIMEOUT, timeout))
       		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_USERAGENT, useragent.c_str()))                        
		&& CURLE_OK == (code = curl_easy_setopt(curl, CURLOPT_URL, url.c_str())))
		{
			code = curl_easy_perform(curl);
		}
		curl_easy_cleanup(curl);
	}
	return code;
}
